 /*
 * Copyright 2008 GigaSpaces Technologies Ltd. All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS," WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. GIGASPACES WILL NOT 
 * BE LIABLE FOR ANY DAMAGE OR LOSS IN CONNECTION WITH THE SOFTWARE.
 */

package com.j_spaces.examples.compress;

import java.io.*;

import com.gigaspaces.annotation.pojo.SpaceClass;
import com.gigaspaces.annotation.pojo.SpaceRouting;
import com.gigaspaces.annotation.pojo.SpaceProperty.IndexType;
import com.gigaspaces.serialization.pbs.PbsFormatter;
import com.gigaspaces.annotation.pojo.SpaceClass.IncludeProperties;
import com.gigaspaces.annotation.pojo.SpaceProperty;

@SpaceClass(includeProperties=IncludeProperties.EXPLICIT ,replicate=true)
public class BinaryFormatEntry implements Externalizable {

	private Integer  _queryField;
	private byte[]   _binary;

////////////
    private Long		_longFieldA1;
    private Long		_longFieldB1;
    private Long		_longFieldC1;
    private Long		_longFieldD1;

    private Integer	_intFieldA1;
    private Integer	_intFieldB1;
    private Integer	_intFieldC1;
    private Integer	_intFieldD1;

    private String	_stringFieldA1;
    private String	_stringFieldB1;
    private String	_stringFieldC1;
    private String	_stringFieldD1;
////

    private Long		_longFieldA2;
    private Long		_longFieldB2;
    private Long		_longFieldC2;
    private Long		_longFieldD2;

    private Integer	_intFieldA2;
    private Integer	_intFieldB2;
    private Integer	_intFieldC2;
    private Integer	_intFieldD2;

    private String	_stringFieldA2;
    private String	_stringFieldB2;
    private String	_stringFieldC2;
    private String	_stringFieldD2;

////
    private Long		_longFieldA3;
    private Long		_longFieldB3;
    private Long		_longFieldC3;
    private Long		_longFieldD3;

    private Integer	_intFieldA3;
    private Integer	_intFieldB3;
    private Integer	_intFieldC3;
    private Integer	_intFieldD3;

    private String	_stringFieldA3;
    private String	_stringFieldB3;
    private String	_stringFieldC3;
    private String	_stringFieldD3;

////////
    public BinaryFormatEntry(){}

    public BinaryFormatEntry(int queryField, 
			long longFieldA1, long longFieldB1, long longFieldC1, long longFieldD1,
                       int intFieldA1, int intFieldB1, int intFieldC1, int intFieldD1,
                       String stringFieldA1, String stringFieldB1, String stringFieldC1, String stringFieldD1,
			long longFieldA2, long longFieldB2, long longFieldC2, long longFieldD2,
                       int intFieldA2, int intFieldB2, int intFieldC2, int intFieldD2,
                       String stringFieldA2, String stringFieldB2, String stringFieldC2, String stringFieldD2,
			long longFieldA3, long longFieldB3, long longFieldC3, long longFieldD3,
                       int intFieldA3, int intFieldB3, int intFieldC3, int intFieldD3,
                       String stringFieldA3, String stringFieldB3, String stringFieldC3, String stringFieldD3)
{
        _queryField   = queryField;

        _longFieldA1   = longFieldA1;
        _longFieldB1   = longFieldB1;
        _longFieldC1   = longFieldC1;
        _longFieldD1   = longFieldD1;
        _intFieldA1    =  intFieldA1;
        _intFieldB1    =  intFieldB1;
        _intFieldC1    =  intFieldC1;
        _intFieldD1    =  intFieldD1;
        _stringFieldA1 = stringFieldA1;
        _stringFieldB1 = stringFieldB1;
        _stringFieldC1 = stringFieldC1;
        _stringFieldD1 = stringFieldD1;
////
        _longFieldA2   = longFieldA2;
        _longFieldB2   = longFieldB2;
        _longFieldC2   = longFieldC2;
        _longFieldD2   = longFieldD2;
        _intFieldA2   =  intFieldA2;
        _intFieldB2    =  intFieldB2;
        _intFieldC2    =  intFieldC2;
        _intFieldD2    =  intFieldD2;
        _stringFieldA2 = stringFieldA2;
        _stringFieldB2 = stringFieldB2;
        _stringFieldC2 = stringFieldC2;
        _stringFieldD2 = stringFieldD2;


///
        _longFieldA3   = longFieldA3;
        _longFieldB3   = longFieldB3;
        _longFieldC3   = longFieldC3;
        _longFieldD3   = longFieldD3;
        _intFieldA3    =  intFieldA3;
        _intFieldB3    =  intFieldB3;
        _intFieldC3    =  intFieldC3;
        _intFieldD3    =  intFieldD3;
        _stringFieldA3 = stringFieldA3;
        _stringFieldB3 = stringFieldB3;
        _stringFieldC3 = stringFieldC3;
        _stringFieldD3 = stringFieldD3;

    }

    @SpaceRouting
    @SpaceProperty(index=IndexType.BASIC)
    public Integer get_queryField()
    {
        return _queryField;
    }
    
    public void set_queryField(Integer queryField)
    {
        _queryField = queryField;
    }

    public void pack()
	{
        long nulls = 0;

        try{

            ByteArrayOutputStream baos = new ByteArrayOutputStream();

            nulls = getnulls();
            PbsFormatter.writeLong(baos, nulls);


            if (_longFieldA1 != null)
            	PbsFormatter.writeLong(baos, _longFieldA1);
            if (_longFieldB1 != null)
            	PbsFormatter.writeLong(baos, _longFieldB1);
            if (_longFieldC1 != null)
            	PbsFormatter.writeLong(baos, _longFieldC1);
            if (_longFieldD1 != null)
            	PbsFormatter.writeLong(baos, _longFieldD1);
            if (_intFieldA1 != null)
            	PbsFormatter.writeInt(baos, _intFieldA1);
            if (_intFieldB1 != null)
            	PbsFormatter.writeInt(baos, _intFieldB1);
            if (_intFieldC1 != null)
            	PbsFormatter.writeInt(baos, _intFieldC1);
            if (_intFieldD1 != null)
            	PbsFormatter.writeInt(baos, _intFieldD1);
            if (_stringFieldA1 != null)
            	PbsFormatter.writeString(baos, _stringFieldA1);
            if (_stringFieldB1 != null)
            	PbsFormatter.writeString(baos, _stringFieldB1);
            if (_stringFieldC1 != null)
            	PbsFormatter.writeString(baos, _stringFieldC1);
            if (_stringFieldD1 != null)
            	PbsFormatter.writeString(baos, _stringFieldD1);

/////////////

            if (_longFieldA2 != null)
            	PbsFormatter.writeLong(baos, _longFieldA2);
            if (_longFieldB2 != null)
            	PbsFormatter.writeLong(baos, _longFieldB2);
            if (_longFieldC2 != null)
            	PbsFormatter.writeLong(baos, _longFieldC2);
            if (_longFieldD2 != null)
            	PbsFormatter.writeLong(baos, _longFieldD2);
            if (_intFieldA2 != null)
            	PbsFormatter.writeInt(baos, _intFieldA2);
            if (_intFieldB2 != null)
            	PbsFormatter.writeInt(baos, _intFieldB2);
            if (_intFieldC2 != null)
            	PbsFormatter.writeInt(baos, _intFieldC2);
            if (_intFieldD2 != null)
            	PbsFormatter.writeInt(baos, _intFieldD2);
            if (_stringFieldA2 != null)
            	PbsFormatter.writeString(baos, _stringFieldA2);
            if (_stringFieldB2 != null)
            	PbsFormatter.writeString(baos, _stringFieldB2);
            if (_stringFieldC2 != null)
            	PbsFormatter.writeString(baos, _stringFieldC2);
            if (_stringFieldD2 != null)
            	PbsFormatter.writeString(baos, _stringFieldD2);

//////////////////

            if (_longFieldA3 != null)
            	PbsFormatter.writeLong(baos, _longFieldA3);
            if (_longFieldB3 != null)
            	PbsFormatter.writeLong(baos, _longFieldB3);
            if (_longFieldC3 != null)
            	PbsFormatter.writeLong(baos, _longFieldC3);
            if (_longFieldD3 != null)
            	PbsFormatter.writeLong(baos, _longFieldD3);
            if (_intFieldA3 != null)
            	PbsFormatter.writeInt(baos, _intFieldA3);
            if (_intFieldB3 != null)
            	PbsFormatter.writeInt(baos, _intFieldB3);
            if (_intFieldC3 != null)
            	PbsFormatter.writeInt(baos, _intFieldC3);
            if (_intFieldD3 != null)
            	PbsFormatter.writeInt(baos, _intFieldD3);
            if (_stringFieldA3 != null)
            	PbsFormatter.writeString(baos, _stringFieldA3);
            if (_stringFieldB3 != null)
            	PbsFormatter.writeString(baos, _stringFieldB3);
            if (_stringFieldC3 != null)
            	PbsFormatter.writeString(baos, _stringFieldC3);
            if (_stringFieldD3 != null)
            	PbsFormatter.writeString(baos, _stringFieldD3);

////////////
            _binary = baos.toByteArray();
            baos.close();
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

	public void unpack() {

        long nulls = 0;

        try{
            int i = 0;
            ByteArrayInputStream bais = new ByteArrayInputStream(_binary);
            nulls = PbsFormatter.readLong(bais);

//////////////
            if( (nulls & 1L << i) == 0 )
                _longFieldA1 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _longFieldB1 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _longFieldC1 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _longFieldD1 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _intFieldA1 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _intFieldB1 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _intFieldC1 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _intFieldD1 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _stringFieldA1 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _stringFieldB1 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _stringFieldC1 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 1L << i) == 0 )
                _stringFieldD1 = PbsFormatter.readString(bais);
            i++;

/////////////

            if( (nulls & 2L << i) == 0 )
                _longFieldA2 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _longFieldB2 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _longFieldC2 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _longFieldD2 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _intFieldA2 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _intFieldB2 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _intFieldC2 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _intFieldD2 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _stringFieldA2 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _stringFieldB2 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _stringFieldC2 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 2L << i) == 0 )
                _stringFieldD2 = PbsFormatter.readString(bais);
            i++;


//////////////
            if( (nulls & 3L << i) == 0 )
                _longFieldA3 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _longFieldB3 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _longFieldC3 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _longFieldD3 = PbsFormatter.readLong(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _intFieldA3 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _intFieldB3 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _intFieldC3 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _intFieldD3 = PbsFormatter.readInt(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _stringFieldA3 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _stringFieldB3 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _stringFieldC3 = PbsFormatter.readString(bais);
            i++;
            if( (nulls & 3L << i) == 0 )
                _stringFieldD3 = PbsFormatter.readString(bais);
            i++;



            bais.close();
            _binary = null;
        }catch (Exception e) {
            e.printStackTrace();
        }
	}

    public void writeExternal(ObjectOutput out) throws IOException {
		short nulls = 0;
        int i=0;

        nulls = checkNulls();

        out.writeShort(nulls);
        if (_queryField != null) {
            out.writeLong(_queryField);
        }
        if (_binary != null) {
            out.write(_binary);
        }
	}

	public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
		short nulls;
        int i=0;
        nulls = in.readShort();

        if( (nulls & 1L << i) == 0 )
          _queryField = in.readInt();
        i++;
        if( (nulls & 1L << i) == 0 )
        {
             byte[] data = new byte[500];
             int len = in.read(data);
             _binary = new byte[len];
             System.arraycopy(data, 0, _binary, 0, len);
        }
	}

	private boolean isDeserializeOnRead()
	{
		return _binary != null;
	}

    private long getnulls()
    {
        long nulls = 0;
        int i=0;


        nulls = ((_longFieldA1 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldB1 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldC1 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldD1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldA1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldB1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldC1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldD1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldA1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldB1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldC1 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldD1 == null) ? nulls | 1L << i : nulls );
        i++;

///////////


        nulls = ((_longFieldA2 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldB2 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldC2 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldD2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldA2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldB2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldC2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldD2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldA2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldB2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldC2 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldD2 == null) ? nulls | 1L << i : nulls );
        i++;

///////////////
        nulls = ((_longFieldA3 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldB3 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldC3 == null)  ? nulls | 1L << i : nulls ) ;
        i++;
        nulls = ((_longFieldD3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldA3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldB3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldC3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_intFieldD3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldA3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldB3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldC3 == null) ? nulls | 1L << i : nulls );
        i++;
        nulls = ((_stringFieldD3 == null) ? nulls | 1L << i : nulls );
        i++;
        return nulls;
    }

    private short checkNulls() {
        short nulls = 0;
        int i = 0;

        nulls = (short) ((_queryField == null) ? nulls | 1 << i : nulls);
        i++;
        nulls = (short) ((_binary == null) ? nulls | 1 << i : nulls);
        i++;
        return nulls;
    }

    @SpaceProperty
	public byte[] get_binary() {
		return _binary;
	}

	public void set_binary(byte[] _binary) {
		this._binary = _binary;
	}

	public Long get_longFieldA1() {
		return _longFieldA1;
	}

	public void set_longFieldA1(Long fieldA1) {
		_longFieldA1 = fieldA1;
	}

	public Long get_longFieldB1() {
		return _longFieldB1;
	}

	public void set_longFieldB1(Long fieldB1) {
		_longFieldB1 = fieldB1;
	}

	public Long get_longFieldC1() {
		return _longFieldC1;
	}

	public void set_longFieldC1(Long fieldC1) {
		_longFieldC1 = fieldC1;
	}

	public Long get_longFieldD1() {
		return _longFieldD1;
	}

	public void set_longFieldD1(Long fieldD1) {
		_longFieldD1 = fieldD1;
	}

	public Integer get_intFieldA1() {
		return _intFieldA1;
	}

	public void set_intFieldA1(Integer fieldA1) {
		_intFieldA1 = fieldA1;
	}

	public Integer get_intFieldB1() {
		return _intFieldB1;
	}

	public void set_intFieldB1(Integer fieldB1) {
		_intFieldB1 = fieldB1;
	}

	public Integer get_intFieldC1() {
		return _intFieldC1;
	}

	public void set_intFieldC1(Integer fieldC1) {
		_intFieldC1 = fieldC1;
	}

	public Integer get_intFieldD1() {
		return _intFieldD1;
	}

	public void set_intFieldD1(Integer fieldD1) {
		_intFieldD1 = fieldD1;
	}

	public String get_stringFieldA1() {
		return _stringFieldA1;
	}

	public void set_stringFieldA1(String fieldA1) {
		_stringFieldA1 = fieldA1;
	}

	public String get_stringFieldB1() {
		return _stringFieldB1;
	}

	public void set_stringFieldB1(String fieldB1) {
		_stringFieldB1 = fieldB1;
	}

	public String get_stringFieldC1() {
		return _stringFieldC1;
	}

	public void set_stringFieldC1(String fieldC1) {
		_stringFieldC1 = fieldC1;
	}

	public String get_stringFieldD1() {
		return _stringFieldD1;
	}

	public void set_stringFieldD1(String fieldD1) {
		_stringFieldD1 = fieldD1;
	}

	public Long get_longFieldA2() {
		return _longFieldA2;
	}

	public void set_longFieldA2(Long fieldA2) {
		_longFieldA2 = fieldA2;
	}

	public Long get_longFieldB2() {
		return _longFieldB2;
	}

	public void set_longFieldB2(Long fieldB2) {
		_longFieldB2 = fieldB2;
	}

	public Long get_longFieldC2() {
		return _longFieldC2;
	}

	public void set_longFieldC2(Long fieldC2) {
		_longFieldC2 = fieldC2;
	}

	public Long get_longFieldD2() {
		return _longFieldD2;
	}

	public void set_longFieldD2(Long fieldD2) {
		_longFieldD2 = fieldD2;
	}

	public Integer get_intFieldA2() {
		return _intFieldA2;
	}

	public void set_intFieldA2(Integer fieldA2) {
		_intFieldA2 = fieldA2;
	}

	public Integer get_intFieldB2() {
		return _intFieldB2;
	}

	public void set_intFieldB2(Integer fieldB2) {
		_intFieldB2 = fieldB2;
	}

	public Integer get_intFieldC2() {
		return _intFieldC2;
	}

	public void set_intFieldC2(Integer fieldC2) {
		_intFieldC2 = fieldC2;
	}

	public Integer get_intFieldD2() {
		return _intFieldD2;
	}

	public void set_intFieldD2(Integer fieldD2) {
		_intFieldD2 = fieldD2;
	}

	public String get_stringFieldA2() {
		return _stringFieldA2;
	}

	public void set_stringFieldA2(String fieldA2) {
		_stringFieldA2 = fieldA2;
	}

	public String get_stringFieldB2() {
		return _stringFieldB2;
	}

	public void set_stringFieldB2(String fieldB2) {
		_stringFieldB2 = fieldB2;
	}

	public String get_stringFieldC2() {
		return _stringFieldC2;
	}

	public void set_stringFieldC2(String fieldC2) {
		_stringFieldC2 = fieldC2;
	}

	public String get_stringFieldD2() {
		return _stringFieldD2;
	}

	public void set_stringFieldD2(String fieldD2) {
		_stringFieldD2 = fieldD2;
	}

	public Long get_longFieldA3() {
		return _longFieldA3;
	}

	public void set_longFieldA3(Long fieldA3) {
		_longFieldA3 = fieldA3;
	}

	public Long get_longFieldB3() {
		return _longFieldB3;
	}

	public void set_longFieldB3(Long fieldB3) {
		_longFieldB3 = fieldB3;
	}

	public Long get_longFieldC3() {
		return _longFieldC3;
	}

	public void set_longFieldC3(Long fieldC3) {
		_longFieldC3 = fieldC3;
	}

	public Long get_longFieldD3() {
		return _longFieldD3;
	}

	public void set_longFieldD3(Long fieldD3) {
		_longFieldD3 = fieldD3;
	}

	public Integer get_intFieldA3() {
		return _intFieldA3;
	}

	public void set_intFieldA3(Integer fieldA3) {
		_intFieldA3 = fieldA3;
	}

	public Integer get_intFieldB3() {
		return _intFieldB3;
	}

	public void set_intFieldB3(Integer fieldB3) {
		_intFieldB3 = fieldB3;
	}

	public Integer get_intFieldC3() {
		return _intFieldC3;
	}

	public void set_intFieldC3(Integer fieldC3) {
		_intFieldC3 = fieldC3;
	}

	public Integer get_intFieldD3() {
		return _intFieldD3;
	}

	public void set_intFieldD3(Integer fieldD3) {
		_intFieldD3 = fieldD3;
	}

	public String get_stringFieldA3() {
		return _stringFieldA3;
	}

	public void set_stringFieldA3(String fieldA3) {
		_stringFieldA3 = fieldA3;
	}

	public String get_stringFieldB3() {
		return _stringFieldB3;
	}

	public void set_stringFieldB3(String fieldB3) {
		_stringFieldB3 = fieldB3;
	}

	public String get_stringFieldC3() {
		return _stringFieldC3;
	}

	public void set_stringFieldC3(String fieldC3) {
		_stringFieldC3 = fieldC3;
	}

	public String get_stringFieldD3() {
		return _stringFieldD3;
	}

	public void set_stringFieldD3(String fieldD3) {
		_stringFieldD3 = fieldD3;
	}
}
