 /*
 * Copyright 2008 GigaSpaces Technologies Ltd. All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS," WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. GIGASPACES WILL NOT 
 * BE LIABLE FOR ANY DAMAGE OR LOSS IN CONNECTION WITH THE SOFTWARE.
 */


package com.j_spaces.examples.compress;

import java.util.Timer;
import java.util.TimerTask;

public class Progress {
	int last=0;
	String symm[] = {"|" ,"/" ,"-","\\"};
	Timer timer = null;
	public void next()
	{
			System.out.print(symm[last]);
			System.out.print("\r");
			last ++;
			if (last==4 ) last =0; 
	}
	
	public void stopAutoProgress()
	{
		timer.cancel();
	}
	public void startAutoProgress()
	{
		timer = new Timer("progress");
		ProgressTask task = new ProgressTask (this);
		timer.schedule(task , 0,500);
	}
	
    public static void main(String[] args) {
    	Progress pr = new Progress();
    	pr.startAutoProgress();
    	try {
			Thread.sleep(5000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	pr.stopAutoProgress();
		
    }
    class ProgressTask extends TimerTask
	{
    	Progress prog;
    	ProgressTask(Progress prog)
    	{
    		this.prog = prog;
    	}
		@Override
		public void run() {
			prog.next();
		}
	}
}
