/*
 /*
 * Copyright 2008 GigaSpaces Technologies Ltd. All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS," WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. GIGASPACES WILL NOT 
 * BE LIABLE FOR ANY DAMAGE OR LOSS IN CONNECTION WITH THE SOFTWARE.
 */

package com.j_spaces.examples.compress.tasks;

import java.util.UUID;

public class MemChecker
{

	private Long      _memUsage;
	private static Runtime  s_runtime = Runtime.getRuntime ();
    

    public MemChecker()
	{
	}
	
	public Long  check() throws Exception
	{
		runGC();
		long totalSum = usedMemory();
		_memUsage = new Long(totalSum);
		return _memUsage;
	}
	
	private  void runGC () throws Exception
    {
        // for whatever reason it helps to call Runtime.gc()
        // using several method calls:
        for (int r = 0; r < 4; ++ r) _runGC ();
    }

    private  void _runGC () throws Exception
    {
        long usedMem1 = usedMemory (), usedMem2 = Long.MAX_VALUE;

        for (int i = 0; (usedMem1 < usedMem2) && (i < 1000); ++ i)
        {
            s_runtime.runFinalization ();
            s_runtime.gc ();
            //Thread.currentThread ().yield ();
            
            usedMem2 = usedMem1;
            usedMem1 = usedMemory ();
            Thread.sleep(1000);
        }
        Thread.sleep(1000);
    }
    
    private  long usedMemory ()
    {
        return s_runtime.totalMemory () - s_runtime.freeMemory ();
    }
}
