package com.j_spaces.example.customfifonotifications;

import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.UnknownEventException;
import java.rmi.RemoteException;

public class OrderedRemoteEventListener <T extends Comparable<T>> implements RemoteEventListener {
    private final OrderingThread<T> _orderingThread;

    public OrderedRemoteEventListener(RemoteEventListener userListener, int queueSize,
                                      ComparableProvider<T> provider)
    {
        this._orderingThread = new OrderingThread<T>(userListener, provider, queueSize);
    }

    public void notify(RemoteEvent theEvent) throws UnknownEventException, RemoteException {
        _orderingThread.notifyOrderEvent( theEvent );
    }
}
