package com.j_spaces.example.customfifonotifications;

import com.j_spaces.core.IJSpace;
import com.j_spaces.core.client.*;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.RemoteEvent;
import net.jini.core.entry.UnusableEntryException;
import net.jini.core.lease.Lease;

public class Test {
    public static void main(String[] args) {
        try {
        	
            IJSpace space = (IJSpace) SpaceFinder.find(args[0]);
            System.out.println("connect to space: " + args[0]);
            space.clear(null , null);
            OrderedRemoteEventListener<Integer> listener =
                    new OrderedRemoteEventListener<Integer>(new MyListener(), Integer.MAX_VALUE, new MessageProvider());
            new NotifyDelegator(space, new Message(), null, listener, Lease.FOREVER, null, false, NotifyModifiers.NOTIFY_ALL);

            Message m1 = new Message("1", "walla", 2 + 5);
            Message m2 = new Message("2", "walla", 1 + 5);
            Message m3 = new Message("3", "walla", 5 + 5);
            Message m4 = new Message("4", "walla", 8 + 5);
            Message m5 = new Message("5", "walla", 6 + 5);
            Message m6 = new Message("6", "walla", 4 + 5);
            Message m7 = new Message("7", "walla", 0 + 5);
            Message m8 = new Message("8", "walla", 3 + 5);
            Message m9 = new Message("9", "walla", 7 + 5);
            Message m10 = new Message("10", "walla", 9 + 5);

            space.write(m1, null, Lease.FOREVER);
            space.write(m2, null, Lease.FOREVER);
            space.write(m3, null, Lease.FOREVER);
            space.write(m4, null, Lease.FOREVER);
            space.write(m5, null, Lease.FOREVER);
            space.write(m6, null, Lease.FOREVER);
            space.write(m7, null, Lease.FOREVER);
            space.write(m8, null, Lease.FOREVER);
            space.write(m9, null, Lease.FOREVER);
            space.write(m10, null, Lease.FOREVER);

            Thread.sleep(100000);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static final class MyListener implements RemoteEventListener {
        public void notify(RemoteEvent theEvent) {
            EntryArrivedRemoteEvent event = (EntryArrivedRemoteEvent) theEvent;
            try {
                Message message = (Message) event.getObject();
                System.out.println("got message with size: " + message.size);
            } catch (UnusableEntryException e) {
                e.printStackTrace();
            }
        }
    }

    private static class MessageProvider implements ComparableProvider<Integer> {
        public Integer getOrderValue(RemoteEvent theEvent) {
            EntryArrivedRemoteEvent event = (EntryArrivedRemoteEvent) theEvent;
            try {
                Message message = (Message) event.getObject();
                return message.size;
            } catch (UnusableEntryException e) {
                e.printStackTrace();
                return null;
            }
        }

        public Integer increment(Integer value) {
            return value + 1;
        }


        public Integer getStartValue() {
            //return 0;
            return 5;
        }
    }

    public static class Message extends MetaDataEntry {
    public String id;
    //Jini specification requires Entry fields be public:
    public String content;

    public Integer size;

    //Jini specification requires public no args constructor:
    public Message() {}

    public Message(String id) {
        this.id = id;
    }

    public Message(String id, String content, Integer size) {
        this.id = id;
        this.content = content;
        this.size = size;
    }

    public Message(String id, String content) {
        this.id = id;
        this.content = content;
    }

    public EntryInfo __getEntryInfo() {
        EntryInfo res = super.__getEntryInfo();
        if (res == null) {
            res = new EntryInfo(id, 0);
        } else {
            res.m_UID = id;
        }

        return res;
    }

    public static String[] __getSpaceIndexedFields() {
        return new String[] {"size"};
    }

}
}
