package com.j_spaces.examples.parentchild;

import java.rmi.RemoteException;

import org.openspaces.core.GigaSpace;

import net.jini.core.entry.UnusableEntryException;
import net.jini.core.transaction.TransactionException;

import com.gigaspaces.annotation.pojo.SpaceClass;
import com.gigaspaces.annotation.pojo.SpaceId;
import com.gigaspaces.annotation.pojo.SpaceProperty;
import com.gigaspaces.annotation.pojo.SpaceProperty.IndexType;
import com.j_spaces.core.client.ClientUIDHandler;
import com.j_spaces.core.client.ExternalEntry;

@SpaceClass
public class Parent  {
	public Parent() {
	}

	public Parent(String id) {
		this.id = id;
	}

	public String childs_uid[];
	transient Child childs[];
	public Long field;
	public String id;
	
	public String _getChildsDetails(GigaSpace space) throws RemoteException, TransactionException, UnusableEntryException
	{
		String ret="";
		Child[] childs = _getChilds(space);
		for (int i=0;i<childs.length ; i++)
		{
			ret = ret + childs[i].toString() + " | ";
		}
		return ret;
		
	}

	public Child[] _getChilds(GigaSpace space) throws RemoteException, TransactionException, UnusableEntryException
	{
		if (childs == null)
		{
			String ChildClassName = Child.class.getName();
			for (int i=0;i<childs_uid.length;i++)
			{
				childs_uid[i] = ClientUIDHandler.createUIDFromName(childs_uid[i] ,ChildClassName  );
			}
			ExternalEntry templateUIDs = new ExternalEntry (childs_uid); 
			Object results[] = space.readMultiple(templateUIDs , Integer.MAX_VALUE);
			childs = new Child[results.length];
			for (int i=0;i<results.length ; i++)
			{
				childs [i] =(Child)  ((ExternalEntry) results[i]).getObject(space.getSpace());
			}
		}
		return childs;
	}
	
	public String _getChildUID()
	{
		String res ="";
		for (int i=0 ; i< childs_uid.length; i++)
		{
			res =res +childs_uid[i] + "\n";
		}
		return res;
	}


	@SpaceProperty(index=IndexType.BASIC)
	public Long getField() {
		return field;
	}

	public void setField(Long field) {
		this.field = field;
	}

	public String[] getChilds_uid() {
		return childs_uid;
	}

	public void setChilds_uid(String[] childs_uid) {
		this.childs_uid = childs_uid;
	}

	@SpaceId(autoGenerate=false)
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
	
}
