package com.j_spaces.core.cluster.replicationfilter;

import java.util.Hashtable;

import com.j_spaces.core.IJSpace;
import com.j_spaces.core.cluster.IReplicationFilter;
import com.j_spaces.core.cluster.IReplicationFilterEntry;
import com.j_spaces.core.cluster.ReplicationPolicy;

public class XMLReplicationFilter  implements IReplicationFilter {
	
    //private int     m_counter = 0;
    @SuppressWarnings("unused")
	private IJSpace m_space = null;
    private final String m_PingObject = "com.j_spaces.tools.cluster.view.ServiceManagerImpl$PingEntry";
    private Hashtable<String, GrantObject> m_hPermittedObjects;
    
	public void close() {
		// TODO Auto-generated method stub

	}

	public void init(IJSpace space, String paramUrl, ReplicationPolicy replicationPolicy) {

		//System.out.println("Init Of Examples filter for Testing ");
		m_space = space;
		//System.out.println(" **************************Loading params from  " +  paramUrl +    " *********************");
		m_hPermittedObjects =   XML2Object.Convert(paramUrl);
		
		if ( m_hPermittedObjects != null )
			System.out.println(" ************************** Loaded Permitted Object hash *********************");
		else
			System.out.println(" ************************** No Permitted Object *********************************");
		
	}

	public void process(int direction, IReplicationFilterEntry replicationFilterEntry, String remoteSpaceMemberName) {
		// TODO Auto-generated method stub
		
		 @SuppressWarnings("unused")
		String filterDirectionStr = null;
		 switch( direction ) 
	     {
	            case IReplicationFilter.FILTER_DIRECTION_INPUT:  filterDirectionStr = "INPUT"; break;
	            case IReplicationFilter.FILTER_DIRECTION_OUTPUT: filterDirectionStr = "OUTPUT"; break;
	     }
		 
		 //load XML --  deal only with replication output 
		 if ( direction ==  IReplicationFilter.FILTER_DIRECTION_INPUT)
			 return;

		 //check if this is Ping and if so ignore 
		 if ( replicationFilterEntry.getClassName().toString().equals(m_PingObject) )
			 return;


	 	System.out.println("********************************************************" );
		System.out.println(replicationFilterEntry.getClassName());
	 	System.out.println("********************************************************" );
	 	//empty filter 
	 	if ( m_hPermittedObjects == null)
	 	{
	 		System.out.println("***********Permitted List was not loadded correctly***************************" );
	 		return;
	 	}
		 //decide if to discard or continue replication 
	 	GrantObject po =   m_hPermittedObjects.get(replicationFilterEntry.getClassName());
		 	
	 	//if object was not found discrard 
	 	if ( po == null )
	 	{
	 		System.out.println("***********Class Not Found***************************" );
	 		replicationFilterEntry.discard();
	 		//replicationFilterEntry.set
	 		return;
	 	} 
		 
	 	//object is found check if field and value match
	 	String[] fieldsNames =   replicationFilterEntry.getFieldsNames();
	 	//taking into account the filter will be done only on primitive
	 	//String[] fieldsValues =  (String[]) replicationFilterEntry.getFieldsValues();
	 	if (fieldsNames == null) return;
	 	for (int i = 0; i < fieldsNames.length; i++) {
	 		//if object match it can be replicated
	 		
			if (po.compareFields(fieldsNames[i],replicationFilterEntry.getFieldValue(i)))
			{
				System.out.println("Object replicated to " + remoteSpaceMemberName);
				return ;
			}
		}
	 	System.out.println("Object will not be replicated to " + remoteSpaceMemberName);
		// if we got to this point the object should not be filter 	
		replicationFilterEntry.discard();
	}
}
