package com.j_spaces.examples.xmlreplicationfilter;

import net.jini.core.entry.Entry;
import net.jini.core.lease.Lease;
import com.j_spaces.core.IJSpace;
import com.j_spaces.core.IJSpaceContainer;
import com.j_spaces.core.client.SpaceFinder;

public class ReplicationFilterTest {

	public static void main(String[] args) {
		System.out.println("welcome to GigaSpaces XML replication filter example!");
		System.out.println("Connect to space " +args[0]);

		try {
			IJSpace space = (IJSpace) SpaceFinder.find(args[0]);
			System.out.println("Connect to space " +args[0] + " OK!");
			
			System.out.println("checking if siteB space active...");
			Utility.waitOnActiveCluster(space , 2000);
			System.out.println("Try Clean cluster...");
			space.clear(new MyEntry (), null);
			System.out.println("Clean cluster OK!");

			MyEntry me = new MyEntry();
			me.m_counter = 1;
			space.write(me, null, Lease.FOREVER);
			System.out.println("Write Entry with m_counter=1   <-- This should be replicated to siteB Space");

			MyEntry me1 = new MyEntry();
			me1.m_counter = 2;
			space.write(me1, null, Lease.FOREVER);
			System.out.println("Write Entry with m_counter=2   <-- This should NOT be replicated to siteB Space");

			System.out.println("Finished Writing ");
			IJSpaceContainer containerSiteA = (IJSpaceContainer)SpaceFinder.find("jini://localhost/siteA_container");
			IJSpaceContainer containerSiteB = (IJSpaceContainer)SpaceFinder.find("jini://localhost/siteB_container");
			IJSpace siteAspace = containerSiteA.getSpace("siteA" , false);
			IJSpace siteBspace = containerSiteB.getSpace("siteB" , false);
			System.out.println("site A space have " + siteAspace.count(new MyEntry() , null) + " MyEntry instance");
			System.out.println("site B space have " + siteBspace.count(new MyEntry() , null) + " MyEntry instance");
			Entry[] resA = siteAspace.readMultiple(new MyEntry() , null , 100);
			Entry[] resB = siteBspace.readMultiple(new MyEntry() , null , 100);

			System.out.println();
			System.out.println("siteA space MyEntry Objects");
			System.out.println("---------------------------");
			for (int i= 0 ; i<resA.length ; i++)
			{
				MyEntry temp = (MyEntry)resA [i];
				System.out.println("m_counter = " + temp.m_counter);
			}
			
			System.out.println();
			System.out.println("siteB space MyEntry Objects");
			System.out.println("---------------------------");
			for (int i= 0 ; i<resB.length ; i++)
			{
				MyEntry temp = (MyEntry)resB [i];
				System.out.println("m_counter = " + temp.m_counter);
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
