package com.gigaspaces.examples.tutorials.ordermanagement;
import net.jini.core.entry.Entry;	// Entry class.
import java.util.Random;			// For the random number generator.

public class Order implements Entry {
    
	public Integer data = null;				 // Order data.
	public String status= null; 			 // Order status, values possible: New/Rejected/Approved.
	public String clientID= null; 			 // The ID of the client that placed the order.
	public Integer number = null;			 // The order number (used to display the fifo function).
    public String validatedByHostname = null;// Hostname of the validator.	
	public Integer m_counter;				 // Used for indexing for partitioned cluster topology.
    
	public Order(){}
	
	//	Processing the order
	public ProcessedOrder process(String hostname)
	{
		ProcessedOrder processedOrder = new ProcessedOrder(); // Creating temporary processedOrder object
		//	Processing the order and saving the result, in this example the Processor simply multiplies the order data by 2
		processedOrder.answer = new Integer(data.intValue() * 2);
		processedOrder.hostname = hostname; //	Stamping which processor processed this order (with its hostname).
		processedOrder.clientID = clientID; //	Stamping which client placed this order (with its unique client ID).
		processedOrder.number = number;		//	Setting the processed order number to match the original order.
		return processedOrder ;
	}
	
	//	Validating the order
	public String validate(String hostname)
	{
		//	For the sake of the example the status is arbitrarily randomized.
		Random RNG = new Random();
		if (RNG.nextInt() % 2 == 0){
			status="Approved";
		}
		else {
			status="Rejected";
		}
		//	Stamping which validator validated this order (with its hostname).
		validatedByHostname=hostname;
		return status;
	}

	//	This method tells the space which property will be indexed for the hashing
	//	mechanism used for partitioning, In the Order class, 
	//	the property m_counter is indexed, as shown below.
	public static String[] __getSpaceIndexedFields() {
	    String[] indexedFields = {"m_counter"};
	    return indexedFields;
	} 
}
